//implementation following this protocol : https://www.epiphan.com/userguides/LUMiO12x/Content/UserGuides/PTZ/3-operation/VISCAcommands.htm#InquiryCommands


// var parameterPath = local.parameters;
// var valuesPath = local.values;

// var state = 
var inquiry = ['CAM_ZoomPosInq', 'CAM_FocusModeInq', 'CAM_FocusPosInq'];

///////////		HELPERS FUNCTIONS	 ////////////////

function printArray(name, array){
	var printHeader = ' '+name+' : ';
	if (array.length){for(var i=0; i<array.length; i++){printHeader+=array[i] + ' ';}}
	script.log(printHeader);
}

///////////		VISCA FUNCTIONS	 ////////////////

function setZoom(ID, position){
	var header = [1, 4, 71];
	var posCommand =	[];
	var pos = Math.round(Math.floor(16384 * position));
	// script.log(pos);
	posCommand[3]=pos%16;
	pos = Math.round(Math.floor(pos/16));
	posCommand[2]=pos%16;
	pos=Math.round(Math.floor(pos/16));
	posCommand[1]=pos%16;
	posCommand[0]=Math.round(Math.floor(pos/16));
	// local.sendBytes(idHex, 1, 4, 71, posCommand, 255);
	
	sendCommand(1, header, posCommand);
}

function sendCommand(id, header, command){
	var idHex = (parseInt("0x80") + ID);
	printArray('header', header);
	printArray('command', command);
	local.sendBytes(idHex, header, command, 255);
}

///////////		SCRIPT FUNCTIONS	 ////////////////

function init() {
	//loadFixtures();
	script.log("VISCA module loaded");
}

var buffer=[];
var bufferIndex = 0 ;
function dataReceived(data)
{
	//If mode is "Lines", you can expect data to be a single line String
	// script.log("Data received : " +data);

	//If mode is anything else, you can expect data to be an array of bytes
	// script.log(" Bytes received : "+data.length);
	// for(var i=0; i < data.length; i++)
	// {
	// 	script.log(" > " + parseInt((""+data[i]),16));
	// }

	//fill buffer with bytes until you find a 255
	for (var i = 0 ; i<data.length ; i++){
		if (data[i]!=255){
			buffer[bufferIndex]=data[i];
			bufferIndex += 1;

		}

		else{
			if(buffer[0]==144){	//0x90, you've got a message
				if (buffer[1]==65){script.log("received command");} //0x41
				if (buffer[1]==81){script.log("complete command");} //0x51
				if (buffer[1]==97){//0x61
					var msg = "error :";
					if(buffer[2]==1){msg=msg+"message length";}
					if(buffer[2]==2){msg=msg+"syntax";}
					if(buffer[2]==3){msg=msg+"command buffer full";}
					if(buffer[2]==4){msg=msg+"command cancelled";}
					if(buffer[2]==5){msg=msg+"no socket";}
					if(buffer[2]==65){msg=msg+"command not executable";}
					else{
							msg=msg+"unknow error";
							for(var j=2; j < buffer.length; j++)
							{
								script.log(" > " +data[i]);
							}
						}
					script.log(msg);
				}

				//inquiry answers
				// if (buffer[1]==80){//0x50){
				// 	switch(inquiry){
				// 		case 'CAM_ZoomPosInq': 

				// 	}
				// }

			}
			bufferIndex = 0;
			buffer=[];
		}

	}
	//then process buffer

}
